#pragma once

#include <tcb_info_session/client.h>
#include <base/connection.h>

namespace Tcb_info { struct Connection; }


struct Tcb_info::Connection : Genode::Connection<Session>, Session_client
{
	enum {
		DEFAULT_BUFFER_SIZE = MERKLE_TREE_SIZE,
		TREE_CALC_RAM_USAGE = 512 * 1024,
	};

	/**
	 * Constructor
	 */
	Connection(Genode::Env &env, char const *label = "", size_t io_buffer_size = DEFAULT_BUFFER_SIZE) :
		Genode::Connection<Session>(env, session(env.parent(),
		                                         "ram_quota=%ld, cap_quota=%ld, label=\"%s\", io_buffer_size=%ld",
		                                         TREE_CALC_RAM_USAGE+io_buffer_size, CAP_QUOTA, label, io_buffer_size)),
		Session_client(env.rm(), cap())
	{ }
};

